{% extends 'main_app/base.html' %}

{% load static %}

{% block specific_css %}
    <link href="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/css/select2.min.css" rel="stylesheet"/>
{% endblock specific_css %}

{% block content %}
    {# Django Tempus Dominus assets are included in `{{ form.media }}` #}
    {{ form.media }}

    <div class="container">
        <div class="row my-5">
            <div class="col-1"></div>
            <div class="col-10">
                <h1>Edit Assignment</h1>

                <a>Change the parameters of the assignment, or upload files to replace the old ones.</a>
                <p>If no file is selected, the old one is kept.</p>

                {% if form.errors %}
                    {% for field in form %}
                        {% for error in field.errors %}
                            <div class="alert alert-danger">
                                <strong>{{ error|escape }}</strong>
                            </div>
                        {% endfor %}
                    {% endfor %}
                    {% for error in form.non_field_errors %}
                        <div class="alert alert-danger">
                            <strong>{{ error|escape }}</strong>
                        </div>
                    {% endfor %}
                {% endif %}
                <form method="post" enctype="multipart/form-data">
                    {% csrf_token %}
                    <div class="form-group">
                        <label for="id_title"><strong>Assignment Title</strong></label>
                        {{ form.title }}
                    </div>
                    <div class="form-group">
                        <label for="id_allowed_languages"><strong>Allowed Languages</strong></label>
                        {{ form.allowed_languages }}
                    </div>
                    <div class="form-group">
                        <label for="id_tags"><strong>Add Tags</strong></label>
                        {{ form.tags }}
                        <br>
                        <a href="" data-toggle="modal" data-target="#createTagModal">+ Create new tag</a>
                    </div>
                    <div class="form-group">
                        <label for="del_tags"><strong>Delete Tags</strong></label>
                        {{ form.current_tags }}
                    </div>

                    <div class="form-group">
                        <label for="id_cleanup_script"><strong>Cleanup Script</strong></label>
                        {{ form.cleanup_script }}
                    </div>
                    <div class="form-group">
                        <label for="id_statement"><strong>Statement</strong></label>
                        {% if assignment.statement %}
                            <br>
                            <a>Old statement:</a>
                            <a href="{{ assignment.statement.url }}">{{ assignment.get_statement_name }}</a>
                            <br>

                            <br>
                            <a>New statement:</a>
                        {% endif %}
                        {{ form.statement }}
                        <small id="statement_help" class="form-text text-muted">PDFs are accepted.</small>
                    </div>
                    <div class="form-group">
                        <label for="id_source"><strong>Source</strong></label>
                        {% if assignment.source %}
                            <br>
                            <a>Old source:</a>
                            <a href="{{ assignment.source.url }}">{{ assignment.get_source_name }}</a>
                            <br>

                            <br>
                        {% endif %}
                        {{ form.source }}
                        <small id="source_help" class="form-text text-muted">The packed source code for the problem.
                        </small>
                    </div>
                    <div class="form-group">
                        <label for="id_deadline"><strong>Deadline</strong></label>
                        {{ form.deadline }}
                    </div>
                    <div class="form-group">
                        <label for="id_period"><strong>Period</strong></label>
                        {{ form.period }}
                    </div>
                    <div class="form-group">
                        <label for="id_published"><strong>Is Published</strong></label>
                        {{ form.published }}
                    </div>
                    <div class="form-group">
                        <label for="id_tests"><strong>Test Cases</strong></label>
                        {% if assignment.tests %}
                            <br>
                            <a>Old test cases:</a>
                            <a href="{{ assignment.tests.url }}">{{ assignment.get_tests_name }}</a>
                            <br>

                            <br>
                            <a>New test cases:</a>
                        {% endif %}
                        {{ form.tests }}
                        <small id="tests_help" class="form-text text-muted">All .csv, .yml, .yaml and .json files are
                            accepted. The format on this file can be found <a href="" data-toggle="modal"
                                                                              data-target=".bd-tutorial-modal-lg">here</a>.
                        </small>
                    </div>
                    <button type="submit" class="btn btn-primary">Submit</button>
                </form>

                <div class="modal fade" id="createTagModal" tabindex="-1" role="dialog"
                     aria-labelledby="createTagModalLabel" aria-hidden="true">
                    <div class="modal-dialog" role="document">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="createTagModalLabel">New Tag</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <iframe src="{% url "create_tag" %}" class="w-100 border-0" height="200px"></iframe>
                            </div>
                        </div>
                    </div>
                </div>

                <div class="modal fade bd-tutorial-modal-lg" tabindex="-1" role="dialog"
                     aria-labelledby="myLargeModalLabel"
                     aria-hidden="true">
                    <div class="modal-dialog modal-lg">
                        <div class="modal-content">
                            <div class="modal-header">
                                <h5 class="modal-title" id="myLargeModalLabel">Accepted Test Files</h5>
                                <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                    <span aria-hidden="true">&times;</span>
                                </button>
                            </div>
                            <div class="modal-body">
                                <h4>Format of the File</h4>
                                <p>A file must contain an array of dictionaries with 4 parameters:</p>
                                <ul>
                                    <li>An Input that must be a string.</li>
                                    <li>An Output that must be a string.</li>
                                    <li>A Comment that must be a string.</li>
                                    <li>And a Test Type must be a string from the following: "public", "semi_private",
                                        "private". (If this field is not one of the previous strings the test will be
                                        taken as private).
                                    </li>
                                </ul>
                                <p>
                                    The Input and Output fields are very self explanatory, the comment is a string that
                                    explains the test and will show with the feedback of the test. Some examples are
                                    "Basic Tests", "Big Numbers Test", "Large Arrays", etc.

                                    The Test Type strinf indicates the type of feedback a test will have when a code
                                    sample
                                    is tested. The string "public" represent Public Tests, "semi_private" represents
                                    Semi-Private Tests and "private"
                                    are Private Tests:
                                </p>

                                <ul>
                                    <li>Public Tests: The feedback for this type of tests consists of a boolean
                                        indicating
                                        if it passed the test or not, the input, the expected output, the resulting
                                        output
                                        and the comment.
                                    </li>
                                    <li>Semi-Private Tests: The feedback for this type of tests consists of just the
                                        boolean
                                        and the comment.
                                    </li>
                                    <li>Semi-Private Tests: These tests aren't shown in the feedback.</li>
                                </ul>

                                <p>
                                    The specifications shown before are only for the student feedback, for the assistant
                                    and
                                    teacher feedback every test wiil be shown as if it were a public test.
                                </p>

                                <h4>File Examples</h4>
                                <h5>Json</h5>
                                <a href="{% static 'file_samples/example_test_file.json' %}"
                                   download="example_test_file.json"><i class="fa fa-file"></i> Download Example
                                    File</a>
                                <pre><code>[
    {
        "Input": "[1,2,3,4]",
        "Output": "1",
        "Comment": "A Comment",
        "Test Type": "public"
    },
    {
        "Input": "[5,6,7,8]",
        "Output": "0",
        "Comment": "Another Coment",
        "Test Type": "private"
    }
]

</code></pre>
                                <h5>Csv</h5>
                                <a href="{% static 'file_samples/example_test_file.csv' %}"
                                   download="example_test_file.csv"><i class="fa fa-file"></i> Download Example File</a>
                                <pre><code>Input,Output,Comment,Test Type
"[1,2,3,4]",1,A Comment,public
"[5,6,7,8]",0,Another Coment,private
</code></pre>
                                <h5>Yml and Yaml</h5>
                                <a href="{% static 'file_samples/example_test_file.yaml' %}"
                                   download="example_test_file.yaml"><i class="fa fa-file"></i> Download Example
                                    File</a>
                                <pre><code>---
- Input: "[1,2,3,4]"
  Output: '1'
  Comment: A Comment
  Test Type: public
- Input: "[5,6,7,8]"
  Output: '0'
  Comment: Another Coment
  Test Type: private
</code></pre>
                            </div>
                            <div class="modal-footer">
                                <button type="button" class="btn btn-secondary" data-dismiss="modal">Close</button>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-1"></div>
        </div>
    </div>
{% endblock content %}

{% block specific_js %}
    <script src="https://cdnjs.cloudflare.com/ajax/libs/select2/4.0.6/js/select2.min.js"></script>
    <script type="text/javascript">
        $(document).ready(function () {
            $("#id_tags").select2();
            $("#id_allowed_languages").select2();

            $('#createTagModal').on('hidden.bs.modal', function () {
                location.reload();
            })
        });
    </script>
{% endblock specific_js %}